function [log_dens,small_component] = eval_2MU(theta_vect,weight_vect,Ubounds)
dim = size(theta_vect);
dim_Ubounds = size(Ubounds);
if(dim(1)~=dim_Ubounds(1))
    error('Not proper size');
end

small_component = (((theta_vect>=Ubounds(:,1,1)) + (theta_vect<=Ubounds(:,2,1)))==2);
large_component = (((theta_vect>Ubounds(:,1,2)) + (theta_vect<Ubounds(:,2,2)))==2);

if(sum(sum(large_component==0))~=0)
    log_dens = -1e17;
else
    bound_a = Ubounds(:,2,1)-Ubounds(:,1,1);
    bound_b = Ubounds(:,2,2)-Ubounds(:,1,2);
    log_dens = sum(log((weight_vect./bound_a).*small_component + (1-weight_vect)./bound_b)); %%% They are necessarily in the large component.
end
