function [phi_sample] = sampling_phi(theta_2MU,Ubounds_2MU,Ubounds_BIC)

bound_a = Ubounds_2MU(:,2,1)-Ubounds_2MU(:,1,1);
bound_b = Ubounds_2MU(:,2,2)-Ubounds_2MU(:,1,2);
dim = size(theta_2MU,1);
Kmax = dim/size(Ubounds_2MU,1);

vect = ones(Kmax,1);
a_vec = kron(vect,bound_a);
b_vec = kron(vect,bound_b);




vect = ones(Kmax,1);
small_component = (((theta_2MU>kron(vect,Ubounds_2MU(:,1,1))) + (theta_2MU<kron(vect,Ubounds_2MU(:,2,1))))==2);


phi_sample = zeros(dim,1);
ind = small_component;
nb_small = sum(ind);
if(nb_small~=0)
   unif = rand(nb_small,1);
   phi_small = (exp(unif.*log((a_vec(ind) + Ubounds_BIC(2)*(b_vec(ind)-a_vec(ind)))./(a_vec(ind) + Ubounds_BIC(1)*(b_vec(ind)-a_vec(ind))))).*(a_vec(ind) + Ubounds_BIC(1)*(b_vec(ind)-a_vec(ind)))-a_vec(ind))./(b_vec(ind)-a_vec(ind));
   phi_sample(ind) = phi_small;
end


ind = (ind~=1);
nb_large = sum(ind);
if(nb_large~=0)
   unif = rand(nb_large,1);
   phi_large = Ubounds_BIC(1) + unif*((Ubounds_BIC(2)-Ubounds_BIC(1))); %%%% Approximation
   phi_sample(ind) = phi_large;
end