function [dens,theta_sorted,sigma_sorted,cass,X_all] = sorting_variables(theta,sigma,cass,regime,taille_ARMA,MA_lags,y,X,spike_and_slab,Prior_on_lags)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Transforms the mean and variance parameters that are in first difference into parameters in level to be able to run the
%%%% log-likelihood function.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if(nargin<10)
    Prior_on_lags = 0;
    if(nargin<9)
        spike_and_slab = 2;
        
    end
end

[theta_sorted,sigma_sorted] = transform_param(theta,sigma,regime,taille_ARMA,Prior_on_lags,spike_and_slab);
if(nargin<7)    
    dens=0;
    X_all = 0;
else
    if(sum(sigma_sorted<=0)==0) 
        [dens,X_all] = dens_CP_ARMA_c(y,X,taille_ARMA,MA_lags,theta_sorted,sigma_sorted,cass);
        if(isreal(dens)==0 || isnan(dens)==1)
            dens = -inf;
            X_all = 0;
        end
    else
        dens = -inf;
        X_all = 0;
    end
end
