function [result] = OLS_estimation_ARX(y,X)
%%%%% OLS estimation
if(size(y,1)<size(y,2))
    y = y';
end
beta_OLS = (X'*X)\(X'*y);
epsilon = (y-X*beta_OLS);
sigma_OLS = (epsilon'*epsilon)/(max(size(epsilon)));
T = max(size(epsilon));
result.log_like = -0.5*T*log(2*pi*sigma_OLS) -0.5*T;% - 0.5*log(sigma_OLS);
result.beta_OLS = beta_OLS';
result.sigma_OLS = sigma_OLS;
result.beta_covar = inv(X'*X/max(size(y)))*sigma_OLS/max(size(y)); %#ok<MINV>
result.beta_std = sqrt(diag(result.beta_covar)');
result.forecast = X(end,:)*beta_OLS;
result.epsilon = epsilon;
