function [log_like,theta,sigma] = log_likelihood_GARCH_with_break_dates(y,log_theta,break_dates,constraint)
if(nargin<4)
    constraint = 0;
end
if(constraint==0)
    theta = log_theta;
    regime = max(size(break_dates));
    if(max(size(log_theta))~=regime*3)
        error('dimension issue')
    end
    error_like = 0;
    if(regime>1)
        vect = zeros(3,1);
        vect(1) = 1;
        indice_omega = logical(kron(ones(regime,1),vect));
        theta(indice_omega) = exp(log_theta(indice_omega));
        
        vect = zeros(3,1);
        vect(3) = 1;
        indice_beta = logical(kron(ones(regime,1),vect));
        theta(indice_beta) = exp(log_theta(indice_beta))./(1+exp(log_theta(indice_beta)));
        
        vect = zeros(3,1);
        vect(2) = 1;
        indice_alpha = logical(kron(ones(regime,1),vect));
        theta(indice_alpha) = (theta(indice_beta)).*exp(log_theta(indice_alpha))./(1+exp(log_theta(indice_alpha)));
    else
        theta(1) = exp(log_theta(1));
        theta(3) = exp(log_theta(3))./(1+exp(log_theta(3)));
        theta(2) = (theta(3)).*exp(log_theta(2))./(1+exp(log_theta(2)));
    end
else
    regime = max(size(break_dates));
    if(size(constraint,2)~=regime || size(constraint,1)~=3)
        error('problem');
    end
    
    nb_param = max(size(log_theta));
    if(sum(sum(constraint==0))~=nb_param)
        error('problem 2')
    end
    if(sum(constraint(:,1))~=0)
        error('problem 3')
    end
    error_like = 0;
    
    ind = 0;
    theta = zeros(3,regime);
    for i=1:regime
        for j=1:3
            if(constraint(j,i)==0)
                ind = ind +1;
                if(j==1)
                    param = exp(log_theta(ind));
                else
                    param = exp(log_theta(ind))/(1+exp(log_theta(ind)));
                end
                theta(j,i) = param;
            else
                theta(j,i) = theta(j,i-1);
            end
        end
    end
    theta = reshape(theta,regime*3,1);
end

if(error_like==0)
    mu = zeros(regime,1); 
    unc_var = theta(1);
    [log_like,sigma] = dens_CP_GARCH_MCMC(y,theta,mu,break_dates,unc_var);
else
    log_like = -1e10;
    sigma = zeros(max(size(y)),1);
end
