function [theta_prop] = D_DREAM(theta,current,CR,nb_chain,current_MCMC)
%%%%%%%% Discrete DREAM proposal
%%%%% For more information, see Bauwens, L., De Backer, B., & Dufays, A. (2014). A Bayesian method of change-point estimation with recurrent regimes: Application to GARCH models. Journal of Empirical Finance, 29, 207-229.
dim = size(theta);
if(dim(1,1)==nb_chain)
    dimension = dim(1,2);
    
else
    dimension = dim(1,1);
    theta = theta';
end
delta = 3;

y_sum = zeros(dimension,2);
for i=1:delta
    random = ceil(rand()*nb_chain);
    while(random==current)
        random = ceil(rand()*nb_chain);
    end
    random2 = ceil(rand()*nb_chain);
    while(random2==random || random2==current)
        random2 = ceil(rand()*nb_chain);
    end
    y_sum(:,1) = y_sum(:,1) + theta(random,:)';
    y_sum(:,2) = y_sum(:,2) + theta(random2,:)';
end

theta_prop = theta(current,:)';

CR_test = (rand(dimension,1)>CR);
dimension_prim = sum(CR_test);
if(mod(current_MCMC,5)==0)
    gamma = 1;
else
    gamma = 2.38/sqrt(2*delta*dimension_prim);
end

std = sqrt(0.00001);
for i=1:dimension
    if(CR_test(i)==1)
        theta_prop(i) = theta(current,i) + round(gamma*(y_sum(i,1)-y_sum(i,2)) + std*randn());
    end
end
