function [theta_prop,log_dens_prop,selection] = SADE_final(theta,log_density,current,CR,nb_chain,current_MCMC,prob_type,a_t_move) %% self-adapting DE
%%% SADE proposal MH distribution.
%%% For more information, see Dufays, A. (2016). Evolutionary sequential Monte Carlo samplers for change-point models. Econometrics, 4(1), 12.
if(nargin<8)
    a_t_move = [2.5 1.5 2.38];
    if(nargin<7)
        prob_type = ones(10,1)/10;
    end
end

dim = size(theta);
if(dim(1,1)==nb_chain)
    dimension = dim(1,2);
    
elseif(dim(1,2)==nb_chain)
    dimension = dim(1,1);
    theta = theta';
else
    error('Taille incorrecte');
end
if(nb_chain<6)
    error('Pas assez de chaines paralleles');
end

selection = multinomialrnd(prob_type,rand());

a = (randperm(nb_chain-1)-1)';
CR_test = (rand(dimension,1)>CR);
dimension_prim = sum(CR_test);
if(dimension_prim==0)
   CR_test(ceil(rand()*dimension)) = 1;
   dimension_prim = 1;
end
log_dens_prop = 0;
y_sum = zeros(dimension,2);

choice = mod(selection,4);

switch choice
    case 1 %%% trigono
        delta = 3;
        random = mod(current+a(1:delta),nb_chain)+1;
        prob1 = log_density(random(1:3));
        maxi = max(prob1);
        prob1 = exp(prob1-maxi);
        prob1 = prob1/sum(prob1);
        theta_t1 = theta(random(1:3),:);
        theta_new = (mean(theta_t1) +  (prob1(2)-prob1(1))*(theta(random(1),:)-theta(random(2),:)) + (prob1(3)-prob1(2))*(theta(random(2),:)-theta(random(3),:)) + (prob1(1)-prob1(3))*(theta(random(3),:)-theta(random(1),:)))';
    case 2 %% DE
        nb_choix = ceil(rand()*2)*2;
        nb_val_mean = ceil(rand()*3);
        delta = nb_val_mean + nb_choix;
        random = mod(current+a(1:delta),nb_chain)+1;
        if(selection<4)
            Expec = (a_t_move(1)+1/a_t_move(1) + 1)/3;
            dist = (Expec)/(1+Expec)*ones(nb_choix,1);
        elseif(selection<8)
            Expec = a_t_move(2)^2/(3*(a_t_move(2)+1));
            dist = (2.38/sqrt(2*(dimension_prim+(dimension_prim==0))))*(Expec)^(-1)*ones(nb_choix,1);
        else
            nb_choix = 0;
            delta = delta - nb_choix;
        end
        theta_new = sum(theta(random(1:nb_val_mean),:),1)'/nb_val_mean;
        for z=1:nb_choix/2
            theta_new = theta_new + (dist(z)*(theta(random(1+z),:)-theta(random(end-z+1),:)))';
        end 
    case 3 %% FF
         nb_choix = ceil(rand()*2);
        nb_val_mean = ceil(rand()*3);
        delta = nb_val_mean + nb_choix;
        random = mod(current+a(1:delta),nb_chain)+1;
        if(selection<4)
            Expec = (a_t_move(1)+1/a_t_move(1) + 1)/3;
            dist = (Expec/(1+Expec))*ones(nb_choix,1);
        elseif(selection<8)
            Expec = a_t_move(2)^2/(3*(a_t_move(2)+1));
            dist = (2.38/sqrt(2*(dimension_prim+(dimension_prim==0))))*(Expec)^(-1)*ones(nb_choix,1);
        else
            dist = ones(nb_choix,1);
        end
        
        theta_new = sum(theta(random(1:nb_val_mean),:),1)'/nb_val_mean;
        for z=1:nb_choix
            theta_new = theta_new + (dist(z)*(theta(random(1+z),:)-theta(random(1),:)))';
        end          
    otherwise
            delta = ceil(rand()*3);
            random = mod(current+a(1:delta),nb_chain)+1;
            theta_new = sum(theta(random,:),1)'/delta;
end

switch selection
    case {1,2,3,4} %% t move
        a_t = a_t_move(1);
        draw = ((1-rand())*(sqrt(1/a_t)-sqrt(a_t))+sqrt(a_t))^2; %% pour simuler la distribution t move
        log_dens_prop = (((dimension_prim==0) + dimension_prim)-1)*log(draw);
        y_sum(:,1) = theta_new;
        y_sum(:,2) = draw*(theta(current,:)'-y_sum(:,1));
    case {5,6,7,8} %% walk move
        a_RW = a_t_move(2);
        draw = ((a_RW + 1)^(1/2) + ((a_RW + 1)^(1/2) - (1/(a_RW + 1))^(1/2))*(rand() - 1))^2 - 1;
        log_dens_prop = log(abs((1+draw)))*(((dimension_prim==0) + dimension_prim)-1);
        y_sum(:,1) = theta(current,:)';
        y_sum(:,2) = draw*(y_sum(:,1)-theta_new);
        
    case {9,10} %% DREAM
        std = 0.00001;
        if(mod(current_MCMC,10)==0)
            gamma = 1;
        else
            gamma = a_t_move(3)/sqrt(2*(dimension_prim+(dimension_prim==0)));
        end
        y_sum(:,1) = theta(current,:)' + std*randn(dimension,1);
        
        random2 = mod(current+a(end-delta+1:end),nb_chain)+1;
        if(rand()<0.5)
            y_sum(:,2) = gamma*(theta_new-sum(theta(random2,:),1)'/delta);
        else
            y_sum(:,2) = -gamma*(theta_new-sum(theta(random2,:),1)'/delta);
        end
end

theta_prop = (CR_test==1).*(y_sum(:,1) + (y_sum(:,2))) + (CR_test==0).*(theta(current,:)');


