function ind = multinomialrnd(vect,unif)
%%%%% Efficient multinomial sampler.
%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% vect can be a matrix but the dimension of the density should be
%%%%%% larger than the dimension of the number of draws
%%%%%%%%%%%%%%%%%%%%%%%%%
dim = size(vect);
nb_draw = max(size(unif));
ind = zeros(nb_draw,1);

if(dim(1)~=nb_draw && dim(2)~=nb_draw)
    error('dimension of draws is different from the number of cdf');
end
if(dim(2)>dim(1))
    vect = vect';
end
cdf = cumsum(vect);
for q=1:nb_draw
   ind(q) = find(cdf(:,q)>unif(q),1); 
end
