function [delta_theta,beta,delta_beta] = sampling_mean_parameters(y,X,delta_theta,var_param,Ubounds_2MU,weight,temper,tau)
T = max(size(y));
sn = trans_sn(tau,T);
regime = size(delta_theta,2);
dimension = size(delta_theta,1)-1;

%%%%%% Interval Griddy Gibbs
nb_inter = 10;
val_inter = zeros(dimension,nb_inter+1);
for z=1:dimension
    interval = 2*Ubounds_2MU(z,2,1)/nb_inter;
    val_inter(z,:) = Ubounds_2MU(z,1,1):interval:Ubounds_2MU(z,2,1);
end

%%%%%%%%%%%%%
%%% Update of beta_1|Y_T,Sigma,delta_beta
%%%%%%%%%%%%%
sigma = exp(cumsum(delta_theta(end,:)))';
delta_beta = delta_theta(1:end-1,2:end);
beta = cumsum(delta_theta(1:end-1,:),2);
sigma_t = sigma(sn);



if(temper>0)
    inv_Sigma_0 = diag(1./var_param(1:end-1));
    if(regime>1)
        aide_beta = [zeros(dimension,1) delta_beta];
        beta_level = cumsum(aide_beta')';
    else
        beta_level = zeros(dimension,1);
    end
    z_t = (y-sum(X.*(beta_level(:,sn)'),2));
    [T,tttt] = cholcov(X'*(repmat(temper./sigma_t,1,dimension).*X) + inv_Sigma_0);
    if(isnan(tttt))
        disp('prob')
        sigma_cond_inv = X'*(repmat(temper./sigma_t,1,dimension).*X) + inv_Sigma_0;
        [~,la] = eig(sigma_cond_inv);
        if(sum(diag(la)<=0)==0)
            for j=2:dimension
                for z=1:j-1
                    sigma_cond_inv(j,z) = sigma_cond_inv(z,j);
                end
            end
        else
            error('prob DP matrix');
        end
        T = cholcov(sigma_cond_inv);
    end
    inv_T = inv(T);
    sigma_cond = inv_T*inv_T';
    mean_post = sigma_cond*temper*(sum(X.*(kron(z_t./sigma_t,ones(1,dimension))))');
    beta(:,1) = mean_post + (cholcov(sigma_cond)'*randn(dimension,1));
end


%%%%%%%%%%%%%
%%% Update of delta beta|Y_T,Sigma,beta_1
%%%%%%%%%%%%%
for q=1:regime-1
    indice_regime  = q+1;
    indice_vect = indice_regime -1;
    indice_sn = (sn>=indice_regime);
    sigma_t_reg = sigma_t(indice_sn);
    X_reg = X(indice_sn,:);
    sn_reg = sn(indice_sn);
    y_reg = y(indice_sn);
    nb_obs_reg = sum(indice_sn);
    if(nb_obs_reg==0)
        for iter_dimension=1:dimension
            z = iter_dimension;
            ratio_var = 2*[Ubounds_2MU(z,2,1) Ubounds_2MU(z,2,2)];
            poids_opt = [weight((q-1)*(dimension+1)+z) 1-weight((q-1)*(dimension+1)+z)];
            z_beta = rand()>poids_opt(1);
            if(z_beta==0)
                delta_beta(z,indice_vect) = -0.5*ratio_var(1) + ratio_var(1)*rand();
            else
                delta_beta(z,indice_vect) = -0.5*ratio_var(2) + ratio_var(2)*rand();
            end
        end
    else
        %%%%% Tirage des z
        for iter_dimension=1:dimension
            z = iter_dimension;
            sigma_cond_inv = X_reg(:,z)'*(X_reg(:,z)./sigma_t_reg);
            if(temper>0 && sigma_cond_inv~=0)
                aide_beta = [beta(:,1) delta_beta];
                aide_beta(z,indice_regime) = 0;
                beta_level = cumsum(aide_beta')';
                z_t = (y_reg-sum(X_reg.*(beta_level(:,sn_reg)'),2));
                sigma_cond = 1/sigma_cond_inv;
                mean_post = sigma_cond*sum(X_reg(:,z).*z_t./sigma_t_reg);
                
                mu_current = mean_post;
                sigma_current = sigma_cond/temper;
                
                ratio_var = 2*[Ubounds_2MU(z,2,1) Ubounds_2MU(z,2,2)];
                poids_opt = [weight((q-1)*(dimension+1)+z) 1-weight((q-1)*(dimension+1)+z)];
                log_f_z1_sur_z0 = log((normcdf(0.5*ratio_var(1),mu_current,sqrt(sigma_current))-normcdf(-0.5*ratio_var(1),mu_current,sqrt(sigma_current))))  - log((normcdf(0.5*ratio_var(2),mu_current,sqrt(sigma_current))-normcdf(-0.5*ratio_var(2),mu_current,sqrt(sigma_current))));
                log_f_prior_z0_sur_z1 = log(ratio_var(2))-log(ratio_var(1));
                log_ratio = log_f_prior_z0_sur_z1+log_f_z1_sur_z0;
                log_prob_z0 = log_ratio + log(poids_opt);
                log_prob_z1 = log((1-poids_opt));
                maxi = max([log_prob_z0 log_prob_z1]);
                prob_z0 = exp(log_prob_z0-maxi)/(exp(log_prob_z0-maxi) + exp(log_prob_z1-maxi));
                z_beta = rand()>prob_z0;
                if(z_beta ==0)
                    
                    sigma_current = sigma_current*temper;
                    log_dens_current = temper*(-0.5*log(2*pi*sigma_current) - 0.5*(val_inter(z,:)-mu_current).^2/sigma_current);
                    [maxi] = max(log_dens_current);
                    dens_current = exp(log_dens_current-maxi);
                    dens_current = dens_current/sum(dens_current);
                    if(isnan(dens_current(1)) || isinf(dens_current(1)))
                        ind = ceil(rand()*(nb_inter+1));
                    else
                        ind = multinomialrnd(dens_current,rand());
                    end
                    delta_beta(z,indice_vect) = val_inter(z,ind);
                else
                    
                    if(abs(mu_current)-sqrt(sigma_current)>0.5*ratio_var(2))
                        delta_beta(z,indice_vect) = -0.5*ratio_var(2) + rand()*ratio_var(2);
                    else
                        low = -0.5*ratio_var(2);
                        up = 0.5*ratio_var(2);
                        std_sigma_current = sqrt(sigma_current);
                        X_rand = trandn((low-mu_current)/std_sigma_current,(up-mu_current)/std_sigma_current);
                        delta_beta(z,indice_vect) = mu_current+std_sigma_current*X_rand;
                        if(abs(delta_beta(z,indice_vect))>0.5*ratio_var(2))
                            delta_beta(z,indice_vect) = -0.5*ratio_var(2) + rand()*ratio_var(2); %%% Variance is too large and makes the distribution identical (or close) to a Uniform.
                        end
                    end
                end
            end
        end
    end
end

aide_beta = [beta(:,1) delta_beta];
delta_theta(1:end-1,:) = aide_beta;
beta = cumsum(aide_beta')';


