function [delta_theta,sigma,z_sigma_save] = sampling_sigma_parameters(delta_theta,Ubounds_2MU,weight,temper,tau,epsilon)

taille = max(size(epsilon));
sn = trans_sn(tau,taille);
regime = size(delta_theta,2);
dim_model = size(delta_theta,1);
Bounds_1reg = 15;

sigma = exp(cumsum(delta_theta(end,:)))';
if(sum(isinf(sigma))~=0)
    ind_inf = find(sigma==inf);
    sigma(ind_inf:end) = 1e8;
end

%%%%%%%%%%%%
%% Update of sigma_1|Y_T,delta_beta,delta_sigma
%%%%%%%%%%%%
%%%%%%%%%%%%%
if(regime>1)
    aide_sigma = [1;sigma(2:end)/sigma(1)];
    eps_1 = epsilon./sqrt(aide_sigma(sn));
else
    eps_1 = epsilon;
end
IG_post_a_MCMC = 0.5*temper*taille + 1;
IG_post_b_MCMC = 0.5*temper*(eps_1')*eps_1;% + 1/IG_b;
sigma_prop = 1/gamrnd(IG_post_a_MCMC,1/IG_post_b_MCMC);
if(abs(log(sigma_prop))<Bounds_1reg*0.5)
    sigma(1) = sigma_prop;
end


%%%%%%%%%%%%%
%%% Update of delta_sigma|Y_T,delta_beta,delta_sigma
%%%%%%%%%%%%%
ratio_var_up = exp([Ubounds_2MU(dim_model,2,1) Ubounds_2MU(dim_model,2,2)]);
ratio_var_down = exp([Ubounds_2MU(dim_model,1,1) Ubounds_2MU(dim_model,1,2)]);


nb_inter = 10;
interval = (ratio_var_up(1)-ratio_var_down(1))/nb_inter;
val_sigma = ratio_var_down(1):interval:ratio_var_up(1);
z_sigma_save = ones(regime,1);
for q=1:regime-1
    indice_regime  = q+1;
    indice_vect = indice_regime -1;
    delta_sigma = sigma(2:end)./sigma(1:end-1);
    indice_sn = (sn>=indice_regime);
    nb_obs_reg = sum(indice_sn);
    poids_opt = [weight((q)*(dim_model)) 1-weight((q)*(dim_model))];
    if(temper>0 && nb_obs_reg>0)
        
        sn_reg = sn(indice_sn);
        if(indice_regime<regime)
            aide_sigma = sigma(indice_regime:end)/delta_sigma(indice_vect);
        else
            aide_sigma = sigma(indice_regime-1);
        end
        
        sigma_t_reg = sqrt(aide_sigma(sn_reg-indice_vect));
        
        eps_1 = epsilon(indice_sn)./sigma_t_reg;
        
        IG_post_a_MCMC =  0.5*temper*sum(indice_sn)+1; %%% From the prior's gradient
        IG_post_b_MCMC =  0.5*temper*(eps_1')*eps_1;
        
        
        %%%%% Tirage des z
        f_z1_sur_z0 = (inversegamcdf(ratio_var_up(1),IG_post_a_MCMC,IG_post_b_MCMC)-inversegamcdf(ratio_var_down(1),IG_post_a_MCMC,IG_post_b_MCMC))/(inversegamcdf(ratio_var_up(2),IG_post_a_MCMC,IG_post_b_MCMC)-inversegamcdf(max(ratio_var_down(2),0.00001),IG_post_a_MCMC,IG_post_b_MCMC));
        
        f_prior_z0_sur_z1 = (Ubounds_2MU(dim_model,2,2)-Ubounds_2MU(dim_model,1,2))/(Ubounds_2MU(dim_model,2,1)-Ubounds_2MU(dim_model,1,1));
        ratio = f_prior_z0_sur_z1*f_z1_sur_z0;
        prob_z0 = ratio*poids_opt/(ratio*poids_opt + (1-poids_opt));
        z_sigma= rand()>prob_z0;
        z_sigma_save(indice_regime) = z_sigma;
        if(z_sigma==0)
            log_dens_current = (inverse_gamma_pdf(val_sigma,IG_post_a_MCMC,1/IG_post_b_MCMC));
            [maxi] = max(log_dens_current);
            dens_current = exp(log_dens_current-maxi);
            dens_current = dens_current/sum(dens_current);
            if(isnan(dens_current(1)) || isinf(dens_current(1)))
                ind = ceil(rand()*max(size(val_sigma)));
            else
                ind = multinomialrnd(dens_current,rand());
            end
            delta_sigma(indice_vect) = val_sigma(ind);
        else
            inv_sigma = gamrnd(IG_post_a_MCMC,1/IG_post_b_MCMC);
            delta_sigma(indice_vect) = 1/inv_sigma;
            if(delta_sigma(indice_vect)>ratio_var_up(2) || delta_sigma(indice_vect)<ratio_var_down(2))
                test_val = 1./(gamrnd(IG_post_a_MCMC,1/IG_post_b_MCMC,100,1));
                ind = (test_val<ratio_var_up(2)).*(test_val>ratio_var_down(2));
                a = find(ind==1,1,'first');
                if(size(a,1)~=0)
                    delta_sigma(indice_vect) = test_val(a);
                else
                    IC = [min(test_val) max(test_val)];
                    if(IC(1)<ratio_var_down(2) && IC(2)>ratio_var_up(2))
                        delta_sigma(indice_vect) = ratio_var_down(2) + rand()*(ratio_var_up(2)-ratio_var_down(2));
                    else
                        t1 = IC<ratio_var_down(2);
                        if(sum(t1)>0)
                            delta_sigma(indice_vect) = ratio_var_down(2) + rand()*(ratio_var_up(2)-ratio_var_down(2))/100;
                        else
                            delta_sigma(indice_vect) = ratio_var_up(2) - rand()*(ratio_var_up(2)-ratio_var_down(2))/100;
                        end
                    end
                end
            end
        end
    else
        z_sigma= rand()>poids_opt(1);
        if(z_sigma==0)
            delta_sigma(indice_vect) = ratio_var_down(1) + rand()*(ratio_var_up(1)-ratio_var_down(1));
        else
            delta_sigma(indice_vect) = ratio_var_down(2) + rand()*(ratio_var_up(2)-ratio_var_down(2));
        end
    end
    aide_sigma = [sigma(1);delta_sigma];
    sigma = cumprod(aide_sigma);
end
delta_theta(end,:) = log(aide_sigma)';
