function [log_theta,log_dens_prior] = simulation_and_eval_from_prior(log_theta,dim_model,mean_param,var_param,type_model,simulation,evaluation)
if(nargin<5)
    evaluation = 0;
    if(nargin<4)
        simulation = 1;
    end
end
log_dens_prior = 0;
switch type_model
    case {'AR','ARMA'}
        if(simulation==1)
            log_theta = mean_param + sqrt(var_param).*randn(dim_model,1);
            log_theta(end) = -0.5*var_param(end) + var_param(end)*rand();
        end
        if(evaluation==1)
            log_dens_prior = sum(-0.5*log(2*pi*var_param(1:end-1)) - 0.5*(log_theta(1:end-1)-mean_param(1:end-1)).^2./var_param(1:end-1)) - log(var_param(end));
        end
    otherwise
        if(simulation==1)
           log_theta = mean_param + sqrt(var_param).*randn(dim_model,1); 
        end
        if(evaluation==1)
           log_dens_prior = sum(-0.5*log(2*pi*var_param) - 0.5*(log_theta-mean_param).^2./var_param);
        end
end