function [test_Box] = test_Box_Pierce(y,lags)
if(nargin<2)
    lags = 50;
end

gamma_0 = mean(y.^2);
mean_y = mean(y);
gamma_j = zeros(lags,1);
taille = max(size(y));
for j=1:lags
    gamma_j(j) = sum(y(1:end-j).*y(j+1:end))/taille - mean_y^2;
end
rho = gamma_j/gamma_0;
Box = taille*sum(rho.^2);

test_Box.rho = rho;
test_Box.gamma_0 = gamma_0;
test_Box.gamma_j = gamma_j;
test_Box.Q_stat = Box;
test_Box.chi2inv_stat = chi2inv(0.95,lags);
test_Box.nb_lags = lags;